package cn.estsh.i3plus.ext.mes.pcn.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.pcn.api.base.IFailCaseCheckDetailService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesFailCaseCheckDetail;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/4 18:05
 **/
@RestController
@Api(tags = "失败事例点检点检")
@RequestMapping(CommonConstWords.BASE_URL_MES_PCN + "/fail-case-check")
public class FailCaseCheckDetailController {
    @Autowired
    private IFailCaseCheckDetailService failCaseCheckDetailService;

    @GetMapping("query")
    @ApiOperation(value = "条件分页")
    public ResultBean queryPager(MesFailCaseCheckDetail detail, Pager pager) {
        try {
            return ResultBean.success("查询成功").setListPager(this.failCaseCheckDetailService.queryByPager(detail, pager))
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping("query-cell")
    @ApiOperation(value = "查询工位下拉框")
    public ResultBean queryCell(MesFailCaseCheckDetail detail) {
        try {
            return ResultBean.success("查询成功").setResultList(this.failCaseCheckDetailService.queryCell(detail))
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @PutMapping("update")
    @ApiOperation(value = "修改")
    public ResultBean update(@RequestBody MesFailCaseCheckDetail detail) {
        try {
            this.failCaseCheckDetailService.update(detail);
            return ResultBean.success("修改成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
